package it.fbk.sra.ejade;

import it.fbk.sra.ejade.preferences.PreferenceConstants;

import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * The activator class controls the plug-in life cycle
 */
public class EjadePlugin extends AbstractUIPlugin {

	// The plug-in ID
	public static final String PLUGIN_ID = "it.fbk.sra.ejade";

	// The shared instance
	private static EjadePlugin plugin;
	
	
	// platform status
	private boolean ready;
	
	/**
	 * The constructor
	 */
	public EjadePlugin() {
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	@Override
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	@Override
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static EjadePlugin getDefault() {
		return plugin;
	}

	// Bundle of getter
	public String getHost(){
		return EjadePlugin.getDefault().getPreferenceStore()
		.getString(PreferenceConstants.P_HOST);
	}
	
	public String getHome(){
		return EjadePlugin.getDefault().getPreferenceStore()
		.getString(PreferenceConstants.EJADE_HOME);
	}
	
	public String getPort(){
		return EjadePlugin.getDefault().getPreferenceStore()
		.getString(PreferenceConstants.P_PORT);
	}
	
	public String getMtpPort(){
		return EjadePlugin.getDefault().getPreferenceStore()
		.getString(PreferenceConstants.P_MTP_PORT);
	}
	
	public String getPlatform(){
		return EjadePlugin.getDefault().getPreferenceStore()
		.getString(PreferenceConstants.PLATFORM);
	}
	
	public String getProxyHost(){
		return EjadePlugin.getDefault().getPreferenceStore()
		.getString(PreferenceConstants.PROXY_HOST);
	}
	
	public String getProxyPort(){
		return EjadePlugin.getDefault().getPreferenceStore()
		.getString(PreferenceConstants.PROXY_HOST);
	}
	
	public boolean isUseUserDefinedParams(){
		return EjadePlugin.getDefault().getPreferenceStore().getBoolean(PreferenceConstants.USE_USER_DEFINED);
	}
	
	public boolean isUseRandomMtp(){
		return EjadePlugin.getDefault().getPreferenceStore().getBoolean(PreferenceConstants.USE_RANDOM_MTP_PORT);
	}
	
	public boolean isStartEcatRemote(){
		return EjadePlugin.getDefault().getPreferenceStore().getBoolean(PreferenceConstants.PLATFORM_WITH_ECAT);
	}
	
	public String getUserDefinedParams(){
		return EjadePlugin.getDefault().getPreferenceStore().getString(PreferenceConstants.USER_DEFINED_PARAMS);
	}
	
	public boolean isReady() {
		return ready;
	}

	public void setReady(boolean ready) {
		this.ready = ready;
	}

}
