package it.fbk.sra.ejade.popup;

import it.fbk.sra.ejade.EjadePlugin;

import java.util.List;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.swt.graphics.Image;

public class AgentNameWizard extends Wizard{

	private List<AgentParam> agentParams;
	
	public AgentNameWizard(List<AgentParam> agentParams) {
		super();
		setWindowTitle("Deploy/Debug Agents");
		setDefaultPageImageDescriptor(getImageDescriptor("icons/eclipse_agent.jpg"));
		setNeedsProgressMonitor(true);
		
		this.agentParams = agentParams;
	}

	@Override
	public boolean performFinish() {
		return true;
	}

	private ImageDescriptor getImageDescriptor(String relativePath) {
		Image image = new Image(EjadePlugin.getDefault().getWorkbench().getDisplay(),
				EjadePlugin.class.getResourceAsStream(relativePath));
		return ImageDescriptor.createFromImage(image);
	}
	
	@Override
	public void addPages() {
		AgentNameWizardPage wizardPage = new AgentNameWizardPage("agentName");
		wizardPage.setTitle("Set agents' names");
		wizardPage.setDescription("Specify name for each agent");
		wizardPage.setAgentParams(agentParams);
    	addPage(wizardPage);
	}
}
