package it.fbk.sra.ejade.popup;


public class AgentParam {

	private String name;
	private String fullClassName;
	private AgentType type;
	private String param;
	private int numClones = 1;
	
	public int getNumClones() {
		return numClones;
	}

	public void setNumClones(int numClones) {
		this.numClones = numClones;
	}

	public enum AgentType{
		JADEX_AGENT("jadex_agent"),
		JADE_AGENT("jade_agent");
		
		private final String value;
		
		AgentType(String v) {
	        value = v;
	    }

	    public String value() {
	        return value;
	    }

	    public static AgentType fromValue(String v) {
	        for (AgentType c: AgentType.values()) {
	            if (c.value.equals(v)) {
	                return c;
	            }
	        }
	        throw new IllegalArgumentException(v);
	    }
	}

	public AgentParam(String name, String fullClassName, AgentType type, String param) {
		this.name = name;
		this.fullClassName = fullClassName;
		this.type = type;
		this.param = param;
	}

	public AgentParam(String name, String fullClassName) {
		this.name = name;
		this.fullClassName = fullClassName;
		this.type = AgentType.JADE_AGENT;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getFullClassName() {
		return fullClassName;
	}

	public void setFullClassName(String fullClassName) {
		this.fullClassName = fullClassName;
	}

	public AgentType getType() {
		return type;
	}

	public void setType(AgentType type) {
		this.type = type;
	}

	public String getParam() {
		return param;
	}

	public void setParam(String param) {
		this.param = param;
	}
	
	
}
