package it.fbk.sra.ejade.preferences;

import it.fbk.sra.ejade.EjadePlugin;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.RadioGroupFieldEditor;
import org.eclipse.jface.preference.StringFieldEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

public class EJADESettings extends FieldEditorPreferencePage implements IWorkbenchPreferencePage{

	
	public EJADESettings() {
		super(1);
        setPreferenceStore(EjadePlugin.getDefault().getPreferenceStore());
        setDescription("EJADE Preferences");
	}

	@Override
	protected void createFieldEditors() {
		
		final Composite parent = getFieldEditorParent();
		
		String[][] platforms = new String[][]{{"JADE", PreferenceConstants.PLATFORM_JADE}
				,{"JADEX", PreferenceConstants.PLATFORM_JADEX}};
		
		addField(new  RadioGroupFieldEditor(PreferenceConstants.PLATFORM, "Platform", 
				2, platforms, getFieldEditorParent(), true));
        
		addField(new StringFieldEditor(PreferenceConstants.P_HOST, "Host:", parent));
		addField(new StringFieldEditor(PreferenceConstants.P_PORT, "Platform port:", parent));

		BooleanFieldEditor userDefindedfield = new BooleanFieldEditor(PreferenceConstants.USE_RANDOM_MTP_PORT, "Use random mtp port (MTP port will be omitted)", parent);
		addField(userDefindedfield);
		
		addField(new StringFieldEditor(PreferenceConstants.P_MTP_PORT, "Platform MTP port:", parent));		
        
        
        userDefindedfield = new BooleanFieldEditor(PreferenceConstants.USE_USER_DEFINED, "Use user defined parametters (Following params will be used)", parent);
        StringFieldEditor userParams = new StringFieldEditor(PreferenceConstants.USER_DEFINED_PARAMS, "User-defined params:", parent);
        //userParams.getTextControl(parent).setEnabled(false);
        
        addField(userDefindedfield);
        addField(userParams);
        
        BooleanFieldEditor startEcatRemote = new BooleanFieldEditor(PreferenceConstants.PLATFORM_WITH_ECAT, "Start eCAT monitoring agent", parent);
		addField(startEcatRemote);
        
        addField(new StringFieldEditor(PreferenceConstants.PROXY_HOST, "Proxy host:", parent));		
        addField(new StringFieldEditor(PreferenceConstants.PROXY_PORT, "Proxy port:", parent));
	}

	public void init(IWorkbench workbench) {
		// Auto-generated method stub
		
	}

}
