package it.fbk.sra.ejade.util;

import it.fbk.sra.ejade.EjadePlugin;

import java.io.IOException;
import java.net.URL;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;

public class CommonUtil {

	/**
	 * Get plugin home
	 * @return
	 */
	public static IPath getPluginPath(){
		URL pluginPath = Platform.getBundle(EjadePlugin.PLUGIN_ID).getEntry("/");
		try {
			if (pluginPath!= null){
				pluginPath = FileLocator.resolve(pluginPath);
				return new Path(pluginPath.getPath());
			}
		} catch (IOException e) {
			
		}
		URL url = FileLocator.find(Platform.getBundle(EjadePlugin.PLUGIN_ID), new Path("/"), null);
		if (url!=null) {
			return new Path(url.getPath());
		}
		return new Path("/");
	}
	
	/**
	 * Get launching parametters
	 * @return
	 */
	public static String launchingParams(){
		String ret;
		
		if (EjadePlugin.getDefault().isUseUserDefinedParams())
			ret = " " + EjadePlugin.getDefault().getUserDefinedParams() + " "; // add spaces
		else {
			String port = EjadePlugin.getDefault().getPort();
			String host = EjadePlugin.getDefault().getHost();
			ret = " -port " + port + " -host " + host + " "; 
		}
		
		return ret ;
	}

}
